#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec4 normal;

in vec3 position;

out vec4 fragColor;

void main() {
    vec4 texCol = texture(Sampler0, texCoord0);
    vec4 color;

    if (texCol.b < 0.1) {
        if (texCol.r < 0.1) {
            color = vec4(fract((position.x + 1.0) / 4.0), fract(position.y / 2.0), 0.0, 1.0);
        }
        else if (texCol.r >= 0.1 && texCol.r < 0.2) {
            color = vec4(fract(min(position.x + 1.0, 6.0) / 4.0), fract(position.y / 2.0), 0.0, 1.0);
        }
        else if (texCol.r >= 0.2 && texCol.r < 0.3) {
            color = vec4(fract((16.0 - (position.x + 1.0)) / 4.0), fract((16.0 - position.y) / 2.0), 0.0, 1.0);
        }
    }
    else if (texCol.a < 0.1) {
        color = vec4(0.0, 0.0, 0.0, 0.0);
    }
    else {
        color = texCol;
    }

    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
